/*
 zenegalircd: a lirc daemon for the BOSE Zenega Set-Top-Box
Copyright (C) 2006 D.Herrendoerfer

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#include <stdio.h>
#include <unistd.h>
#include <linux/input.h>

#include "zenegalircd.h"

int lastvalue,lastcount;
int prestop=0;
char messagebuf[128];

char *keys[256] = {
        "", "", "1", "2", "3", "4", "5", "6", "7", "8", "9", "0", "", "", "CANCEL", "",
        "", "", "", "", "", "", "", "", "", "", "", "", "OK", "", "", "",
        "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
        "", "", "", "", "", "", "", "", "", "", "", "TONLINE", "HOME", "STOP", "PLAY", "PREV",
        "REW", "FWD", "NEXT", "RED", "GREEN", "HELP", "MUTE", "CHUP", "EPG", "VOLUP", "?", "*", "EXIT", "RAUTE", "", "CHDOWN",
        "INFO", "VOLDOWN", "MENU", "", "", "", "", "YELLOW", "BLUE", "", "", "", "", "", "", "",
        "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
        "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
        "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
        "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
        "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
        "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
        "", "", "", "", "", "", "", "", "UP", "", "", "LEFT", "", "RIGHT", "", "",
        "DOWN", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
        "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
        "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""
};

char *getKey(int efd)
{
        struct input_event ev[64];
        int rd, value, size = sizeof (struct input_event);

        if ((rd = read (efd, ev, size * 64)) < size)
                return NULL;

        value = ev[0].value;
        if (value != ' ' && ev[1].value == 1 && ev[1].type == 1)
        {
                //printf ("0x0%04x=", value);
		if (value == 0x3c)
		{
			//printf("ALT\n");
			
			if (lastvalue == 0x3c)
			{
                        	sprintf(messagebuf,"000000000000%04x %02i %s ZENEGA\n"
					,value,lastcount,keys[value]);
				lastvalue = 0;
                        	return messagebuf;
			}
			else
			{
				lastvalue = value;
				return NULL;
			}
			 
		}
                else if (keys[value] != NULL)
                {
                        //printf ("%s\n", (keys[value]));
                        /*
                        if (lastvalue == value)
                                lastcount++;
                        else
                                lastcount=0;
                        */
                        lastcount=0;
			
			if (lastvalue == 0x3c)
			{
                        	sprintf(messagebuf,"000000000000%04x %02i ALT-%s ZENEGA\n"
					,value,lastcount,keys[value]);
                        }
			else if ( prestop == 0 && value == 0x3d)
			{
                        	sprintf(messagebuf,"000000000000%04x %02i PAUSE ZENEGA\n"
					,value,lastcount);
				prestop = 1;
				value = 0x13d;
                        }
			else if ( prestop == 1 && value == 0x3e)
			{
                        	sprintf(messagebuf,"000000000000%04x %02i PAUSE ZENEGA\n"
					,value,lastcount);
				prestop = 0;
				value = 0x13e;
                        }
			else
			{
                        	sprintf(messagebuf,"000000000000%04x %02i %s ZENEGA\n"
					,value,lastcount,keys[value]);

				// clear prestop on certain key - presses
				if (value == 0x3c || value == 0x3d || value == 0x3f || value == 0x42)
				{
					prestop=0;
				}
			}

			
			lastvalue = value;
                        return messagebuf;
                }
                else
                {
                        return "unknown";
                }
        }
        return NULL;
}
